<?php
/**
 * BookiFlex Core
 *
 * @package    BookiFlex
 * @subpackage Core
 * @author     BookiFlex
 * @copyright  Copyright (c) 2025 BookiFlex
 * @license    GPL-2.0-or-later
 *
 * @link       https://bookiflex.com
 */

declare(strict_types=1);

namespace BookiFlex\Core\ORM\Typecast;

use BookiFlex\Core\Model\Reservation\GroupReservationStatus;
use Cycle\ORM\Parser\CastableInterface;
use Cycle\ORM\Parser\UncastableInterface;

defined( 'ABSPATH' ) || exit;

class ReservationGroupTypecast implements CastableInterface, UncastableInterface
{
    public function setRules(array $rules): array
    {
        // Can set rules here if needed
        return $rules;
    }

    public function cast(array $data): array
    {
        if (isset($data['status']) && is_string($data['status'])) {
            $data['status'] = new GroupReservationStatus($data['status']);
        }

        return $data;
    }

    public function uncast(array $data): array
    {
        if (isset($data['status']) && $data['status'] instanceof GroupReservationStatus) {
            $data['status'] = (string) $data['status'];
        }

        return $data;
    }
}
